#include <stdlib.h>
#include "walford.h"

#define FIXED_DECIMAL    5   // how many bits are there for fixed "decimal point"
#define WALFORD_CUTOFF  32   // depth of real history

uint8_t walfordCount = 0;    // goes up to WALFORD_CUTOFF
int16_t walfordMeanEx = 0;   // 15 bits should be enough

void walford_init(void) {
    walfordCount = 0;
    walfordMeanEx = 0;
}

void walford_add(uint16_t value) {  // expected 10 bit values (0-1023)
    walfordCount += 1;
    if (walfordCount > WALFORD_CUTOFF) { walfordCount >>= 1; }  // once over cutoff, "forget" the last half of entries
    int16_t delta = (int16_t)(value << FIXED_DECIMAL) - walfordMeanEx;
    walfordMeanEx += delta / walfordCount;
}

uint16_t walford_getMean(void) {
    int16_t value = (walfordMeanEx >> FIXED_DECIMAL);
    return (value > 0) ? (uint16_t)value : 0;
}
